const { DataTypes } = require('sequelize');

module.exports = (sequelize) => {
    const Religion = sequelize.define('religion', {
        id: {
            type: DataTypes.INTEGER,
            autoIncrement: true,
            primaryKey: true
        },
        creation: { type: DataTypes.DATE, allowNull: false },
        modified: { type: DataTypes.DATE, allowNull: false },
        modified_by: { type: DataTypes.INTEGER, allowNull: false },
        owner: { type: DataTypes.INTEGER, allowNull: false },
        enabled: { type: DataTypes.BOOLEAN, allowNull: false },

        // main
        name: { type: DataTypes.STRING(50), allowNull: false },
        display_name: { type: DataTypes.STRING(50), allowNull: false },
        
        // fk
        company_id: {
            type: DataTypes.INTEGER,
            allowNull: true,
            references: {
                model: 'companies',
                key: 'id'
            }
        },
    }, {
        tableName: 'religions',
        freezeTableName: true
    });

    /**
     * Associates the Religion model with other models.
     * @param {object} models - The models to associate with.
     * @description
     */
    Religion.associate = (models) => {
        Religion.belongsTo(models.Company, { foreignKey: "company_id", as: "company" }); 

        Religion.hasMany(models.Employee, {
            foreignKey: "religion_id",
            as: "employees",
        });

        Religion.hasMany(models.Patient, {
            foreignKey: "religion_id",
            as: "patients",
        });
    };

    return Religion;
};
